<template>
    <div :class="{'cliente': !isPremium, 'cliente-premium': isPremium}">
        <h4>Nome: {{ propCliente.nome }}</h4>
        <hr>
        <p>{{descricao}}</p>
        <hr>
        <p>Email: {{propCliente.email | processarEmail}}</p>
        <p v-if="showAge === true">Idade: {{propCliente.idade}}</p>
        <p v-else>A idade está econdida</p>
        <button @click="mudarCor($event)">Mudar cor</button>
        <button @click="emitirEventoDelete">Deletar</button>
        <h4>{{idEspecial}}</h4>
    </div>
</template>

<script>
export default {
    data(){
        return{
            descricao: "I do not need your help, Zeus!",
            isPremium: false
        }
    },
    props: {
        propCliente: Object,
        showAge: Boolean
    },
    methods: {
        mudarCor: function($event){
            console.log($event);
            this.isPremium = !this.isPremium;
        },
        emitirEventoDelete: function(){
            console.log("Emitindo evento");
            this.$emit("meDelete", {idCliente: this.propCliente.id, curso: "Formação Node.js", emPromocao: true, component: this});
        },
        testaPassagemMetodos: function(){
            console.log("Testando passagem de método");
            alert("Testando passagem de métodos");
        }       
    },
    filters: {
        //Filtros sempre recebem um valor e retornam outro
        processarEmail: function(value){
            return value.toUpperCase();
        }
    },
    computed: {
        //Computed Properties sempre retornam valor
        idEspecial: function(){
            return(this.propCliente.email + this.propCliente.nome + this.propCliente.id).toUpperCase();
        }
    }
}
</script>

<style scoped>
    .cliente{
        background-color: #dbd3d1;
        max-width: 600px;
        height: 220px;
        color: blueviolet;
        padding: 1%;
        margin-top: 2%;
    }
    .cliente-premium{
        background-color: darkcyan;
        max-width: 600px;
        height: 220px;
        color: crimson;
        padding: 1%;
        margin-top: 2%;
    }

</style>